Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2269)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2270)
@@ -20,5 +20,4 @@
 ! Current revisions:
 ! -----------------
-! 
 ! 
 ! 
@@ -26,4 +25,13 @@
 ! -----------------
 ! $Id$
+! Revised parameterization of heat conductivity between skin layer and soil.
+! Temperature and moisture are now defined at the center of the layers.
+! Renamed veg_type to vegetation_type and pave_type to pavement_type_name
+! Renamed and reduced the number of look-up tables (vegetation_pars, soil_pars)
+! Revised land surface model initialization
+! Removed output of shf_eb and qsws_eb and removed _eb throughout code
+! Removed Clapp & Hornberger parameterization
+! 
+! 2249 2017-06-06 13:58:01Z sward
 ! 
 ! 2248 2017-06-06 13:52:54Z sward $
@@ -50,5 +58,5 @@
 ! 
 ! 2149 2017-02-09 16:57:03Z scharf
-! Land surface parameters II corrected for veg_type 18 and 19
+! Land surface parameters II corrected for vegetation_type 18 and 19
 ! 
 ! 2031 2016-10-21 15:11:58Z knoop
@@ -177,5 +185,5 @@
 ! ------------
 !> Land surface model, consisting of a solver for the energy balance at the
-!> surface and a four layer soil scheme. The scheme is similar to the TESSEL
+!> surface and a multi layer soil scheme. The scheme is similar to the TESSEL
 !> scheme implemented in the ECMWF IFS model, with modifications according to
 !> H-TESSEL. The implementation is based on the formulation implemented in the 
@@ -195,5 +203,9 @@
 !>       with considerable precipitation.
 !> @todo Fix crashes with radiation_scheme == 'constant'
-!>
+!> @todo Revise calculation of f2 when wilting point is non-constant in the
+!>       soil
+!> @todo Solve problems with soil heat flux paramterization
+!> @todo Make pavement_depth variable for each surface element
+!> @todo Allow for zero soil moisture (currently, it is set to wilting point)
 !> @note No time step criterion is required as long as the soil layers do not
 !>       become too thin.
@@ -211,6 +223,6 @@
                initializing_actions, intermediate_timestep_count_max,          &
                land_surface, max_masks, precipitation, pt_surface,             &
-               rho_surface, roughness_length, surface_pressure,                &
-               timestep_scheme, tsc, z0h_factor, time_since_reference_point
+               rho_surface, surface_pressure, timestep_scheme, tsc,            &
+               time_since_reference_point
 
     USE indices,                                                               &
@@ -223,10 +235,11 @@
     USE radiation_model_mod,                                                   &
         ONLY:  force_radiation_call, rad_net, rad_sw_in, rad_lw_out,           &
-               rad_lw_out_change_0, radiation_scheme, unscheduled_radiation_calls
+               rad_lw_out_change_0, radiation_scheme,                          &
+               unscheduled_radiation_calls
         
     USE statistics,                                                            &
         ONLY:  hom, statistic_regions
 
-    USE surface_mod,                                                        &
+    USE surface_mod,                                                           &
         ONLY :  surf_lsm_h, surf_lsm_v, surf_type
 
@@ -243,10 +256,10 @@
     REAL(wp), PARAMETER  ::                    &
               b_ch               = 6.04_wp,    & ! Clapp & Hornberger exponent
-              lambda_h_dry       = 0.19_wp,    & ! heat conductivity for dry soil   
-              lambda_h_sm        = 3.44_wp,    & ! heat conductivity of the soil matrix
-              lambda_h_water     = 0.57_wp,    & ! heat conductivity of water
+              lambda_h_dry       = 0.19_wp,    & ! heat conductivity for dry soil (W/m/K)  
+              lambda_h_sm        = 3.44_wp,    & ! heat conductivity of the soil matrix (W/m/K)
+              lambda_h_water     = 0.57_wp,    & ! heat conductivity of water (W/m/K)
               psi_sat            = -0.388_wp,  & ! soil matrix potential at saturation
-              rho_c_soil         = 2.19E6_wp,  & ! volumetric heat capacity of soil
-              rho_c_water        = 4.20E6_wp,  & ! volumetric heat capacity of water
+              rho_c_soil         = 2.19E6_wp,  & ! volumetric heat capacity of soil (J/m3/K)
+              rho_c_water        = 4.20E6_wp,  & ! volumetric heat capacity of water (J/m3/K)
               m_max_depth        = 0.0002_wp     ! Maximum capacity of the water reservoir (m)
 
@@ -260,12 +273,22 @@
 !
 !-- LSM variables
-    INTEGER(iwp) :: nzb_soil = 0,  & !< bottom of the soil model (Earth's surface)
-                    nzt_soil = 0,  & !< top of the soil model
-                    nzs = 0,       & !< number of soil layers
-                    veg_type  = 2, & !< default NAMELIST veg_type_2d
-                    soil_type = 3    !< default NAMELIST soil_type_2d
+    CHARACTER(10) :: surface_type = 'netcdf'  !< general classification. Allowed are:
+                                             !< 'vegetation', 'pavement', ('building'), 
+                                             !< 'water', and 'netcdf'
+
+
+
+    INTEGER(iwp) :: nzb_soil = 0,        & !< bottom of the soil model (Earth's surface)
+                    nzt_soil = 7,        & !< top of the soil model
+                    nzs = 8,             & !< number of soil layers
+                    pavement_type = 1,   & !< default NAMELIST pavement_type                 
+                    soil_type = 3,       & !< default NAMELIST soil_type
+                    vegetation_type = 2, & !< default NAMELIST vegetation_type
+                    water_type = 1         !< default NAMELISt water_type
+                    
    
         
     LOGICAL :: conserve_water_content = .TRUE.,  & !< open or closed bottom surface for the soil model
+               constant_roughness = .FALSE.,     & !< use fixed/dynamic roughness lengths for water surfaces
                force_radiation_call_l = .FALSE., & !< flag to force calling of radiation routine
                aero_resist_kray = .TRUE.           !< flag to control parametrization of aerodynamic resistance at vertical surface elements
@@ -275,5 +298,5 @@
     REAL(wp) :: alpha_vangenuchten = 9999999.9_wp,      & !< NAMELIST alpha_vg
                 canopy_resistance_coefficient = 9999999.9_wp, & !< NAMELIST g_d
-                c_surface   = 20000.0_wp,               & !< Surface (skin) heat capacity
+                c_surface = 9999999.9_wp,               & !< Surface (skin) heat capacity (J/m2/K)
                 drho_l_lv,                              & !< (rho_l * l_v)**-1
                 exn,                                    & !< value of the Exner function
@@ -283,7 +306,7 @@
                 hydraulic_conductivity = 9999999.9_wp,  & !< NAMELIST gamma_w_sat
                 ke = 0.0_wp,                            & !< Kersten number
-                lambda_h_sat = 0.0_wp,                  & !< heat conductivity for saturated soil
-                lambda_surface_stable = 9999999.9_wp,   & !< NAMELIST lambda_surface_s
-                lambda_surface_unstable = 9999999.9_wp, & !< NAMELIST lambda_surface_u
+                lambda_h_sat = 0.0_wp,                  & !< heat conductivity for saturated soil (W/m/K)
+                lambda_surface_stable = 9999999.9_wp,   & !< NAMELIST lambda_surface_s (W/m2/K)
+                lambda_surface_unstable = 9999999.9_wp, & !< NAMELIST lambda_surface_u (W/m2/K)
                 leaf_area_index = 9999999.9_wp,         & !< NAMELIST lai
                 l_vangenuchten = 9999999.9_wp,          & !< NAMELIST l_vg
@@ -292,7 +315,7 @@
                 m_total = 0.0_wp,                       & !< weighted total water content of the soil (m3/m3)
                 n_vangenuchten = 9999999.9_wp,          & !< NAMELIST n_vg
-                pave_depth = 9999999.9_wp,              & !< depth of the pavement
-                pave_heat_capacity = 1.94E6_wp,         & !< volumetric heat capacity of pavement (e.g. roads)
-                pave_heat_conductivity = 1.00_wp,       & !< heat conductivity for pavements (e.g. roads)
+                pavement_depth = 9999999.9_wp,          & !< depth of the pavement
+                pavement_heat_capacity = 9999999.9_wp,  & !< volumetric heat capacity of pavement (e.g. roads) (J/m3/K)
+                pavement_heat_conduct  = 9999999.9_wp,  & !< heat conductivity for pavements (e.g. roads) (W/m/K)
                 q_s = 0.0_wp,                           & !< saturation specific humidity
                 residual_moisture = 9999999.9_wp,       & !< NAMELIST m_res
@@ -303,22 +326,31 @@
                 skip_time_do_lsm = 0.0_wp,              & !< LSM is not called before this time
                 vegetation_coverage = 9999999.9_wp,     & !< NAMELIST c_veg
+                water_temperature = 9999999.9_wp,       & !< water temperature
                 wilting_point = 9999999.9_wp,           & !< NAMELIST m_wilt
-                z0_eb  = 9999999.9_wp,                  & !< NAMELIST z0 (lsm_par)
-                z0h_eb = 9999999.9_wp,                  & !< NAMELIST z0h (lsm_par)
-                z0q_eb = 9999999.9_wp                     !< NAMELIST z0q (lsm_par)
-
+                z0_vegetation  = 9999999.9_wp,          & !< NAMELIST z0 (lsm_par)
+                z0h_vegetation = 9999999.9_wp,          & !< NAMELIST z0h (lsm_par)
+                z0q_vegetation = 9999999.9_wp,          & !< NAMELIST z0q (lsm_par)
+                z0_pavement    = 9999999.9_wp,          & !< NAMELIST z0 (lsm_par)
+                z0h_pavement   = 9999999.9_wp,          & !< NAMELIST z0h (lsm_par)
+                z0q_pavement   = 9999999.9_wp,          & !< NAMELIST z0q (lsm_par)
+                z0_water       = 9999999.9_wp,          & !< NAMELIST z0 (lsm_par)
+                z0h_water      = 9999999.9_wp,          & !< NAMELIST z0h (lsm_par)
+                z0q_water      = 9999999.9_wp             !< NAMELIST z0q (lsm_par)  
+                
+                
     REAL(wp), DIMENSION(:), ALLOCATABLE  :: ddz_soil,         & !< 1/dz_soil
-                                            ddz_soil_stag,    & !< 1/dz_soil_stag
-                                            dz_soil,          & !< soil grid spacing (edge-edge)
-                                            dz_soil_stag,     & !< soil grid spacing (center-center)
+                                            ddz_soil_layer,   & !< 1/dz_soil_layer
+                                            dz_soil,          & !< soil grid spacing (center-center)
+                                            dz_soil_layer,    & !< soil grid spacing (edge-edge)
                                             root_extr           !< root extraction
 
 
                                             
-    REAL(wp), DIMENSION(0:20)  ::  root_fraction = 9999999.9_wp,               & !< distribution of root surface area to the individual soil layers
+    REAL(wp), DIMENSION(0:20)  ::  root_fraction = 9999999.9_wp,               & !< (NAMELIST) distribution of root surface area to the individual soil layers
                                    soil_moisture = 0.0_wp,                     & !< NAMELIST soil moisture content (m3/m3)
                                    soil_temperature = 300.0_wp,                & !< NAMELIST soil temperature (K) +1
-                                   zs = 9999999.9_wp                             !< soil layer depths
-                                   
+                                   zs = 9999999.9_wp,                          & !< (NAMELIST) soil layer depths (center)
+                                   zs_layer = 9999999.9_wp                       !< soil layer depths (edge)
+                                 
 #if defined( __nopointer )
     TYPE(surf_type_lsm), TARGET  ::  t_soil_h,    & !< Soil temperature (K), horizontal surface elements
@@ -359,40 +391,40 @@
     TYPE(surf_type_lsm), TARGET   ::  t_surface_h,    & !< surface temperature (K), horizontal surface elements 
                                       t_surface_h_p,  & !< progn. surface temperature (K), horizontal surface elements 
-                                      m_liq_eb_h,     & !< liquid water reservoir (m), horizontal surface elements 
-                                      m_liq_eb_h_p      !< progn. liquid water reservoir (m), horizontal surface elements 
+                                      m_liq_h,     & !< liquid water reservoir (m), horizontal surface elements 
+                                      m_liq_h_p      !< progn. liquid water reservoir (m), horizontal surface elements 
 
     TYPE(surf_type_lsm), DIMENSION(0:3), TARGET   ::  &
                                       t_surface_v,    & !< surface temperature (K), vertical surface elements 
                                       t_surface_v_p,  & !< progn. surface temperature (K), vertical surface elements 
-                                      m_liq_eb_v,     & !< liquid water reservoir (m), vertical surface elements 
-                                      m_liq_eb_v_p      !< progn. liquid water reservoir (m), vertical surface elements 
+                                      m_liq_v,     & !< liquid water reservoir (m), vertical surface elements 
+                                      m_liq_v_p      !< progn. liquid water reservoir (m), vertical surface elements 
 #else
     TYPE(surf_type_lsm), POINTER  ::  t_surface_h,    & !< surface temperature (K), horizontal surface elements 
                                       t_surface_h_p,  & !< progn. surface temperature (K), horizontal surface elements 
-                                      m_liq_eb_h,     & !< liquid water reservoir (m), horizontal surface elements 
-                                      m_liq_eb_h_p      !< progn. liquid water reservoir (m), horizontal surface elements 
+                                      m_liq_h,     & !< liquid water reservoir (m), horizontal surface elements 
+                                      m_liq_h_p      !< progn. liquid water reservoir (m), horizontal surface elements 
 
     TYPE(surf_type_lsm), TARGET   ::  t_surface_h_1,  & !<
                                       t_surface_h_2,  & !<
-                                      m_liq_eb_h_1,   & !<
-                                      m_liq_eb_h_2      !<
+                                      m_liq_h_1,   & !<
+                                      m_liq_h_2      !<
 
     TYPE(surf_type_lsm), DIMENSION(:), POINTER  ::    &
                                       t_surface_v,    & !< surface temperature (K), vertical surface elements 
                                       t_surface_v_p,  & !< progn. surface temperature (K), vertical surface elements 
-                                      m_liq_eb_v,     & !< liquid water reservoir (m), vertical surface elements 
-                                      m_liq_eb_v_p      !< progn. liquid water reservoir (m), vertical surface elements 
+                                      m_liq_v,     & !< liquid water reservoir (m), vertical surface elements 
+                                      m_liq_v_p      !< progn. liquid water reservoir (m), vertical surface elements 
 
     TYPE(surf_type_lsm), DIMENSION(0:3), TARGET   ::  &
                                       t_surface_v_1,  & !<
                                       t_surface_v_2,  & !<
-                                      m_liq_eb_v_1,   & !<
-                                      m_liq_eb_v_2      !<
+                                      m_liq_v_1,   & !<
+                                      m_liq_v_2      !<
 #endif
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: m_liq_eb_av
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: m_liq_av
 #else
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: m_liq_eb_av
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: m_liq_av
 #endif
 
@@ -405,10 +437,10 @@
 #endif
 
-    TYPE(surf_type_lsm), TARGET ::  tm_liq_eb_h_m   !< liquid water reservoir tendency (m), horizontal surface elements 
+    TYPE(surf_type_lsm), TARGET ::  tm_liq_h_m   !< liquid water reservoir tendency (m), horizontal surface elements 
     TYPE(surf_type_lsm), TARGET ::  tt_surface_h_m  !< surface temperature tendency (K), horizontal surface elements 
     TYPE(surf_type_lsm), TARGET ::  tt_soil_h_m     !< t_soil storage array, horizontal surface elements 
     TYPE(surf_type_lsm), TARGET ::  tm_soil_h_m     !< m_soil storage array, horizontal surface elements 
 
-    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tm_liq_eb_v_m   !< liquid water reservoir tendency (m), vertical surface elements 
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tm_liq_v_m   !< liquid water reservoir tendency (m), vertical surface elements 
     TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tt_surface_v_m  !< surface temperature tendency (K), vertical surface elements 
     TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tt_soil_v_m     !< t_soil storage array, vertical surface elements 
@@ -421,44 +453,40 @@
               c_soil_av,        & !< average of c_soil
               c_veg_av,         & !< average of c_veg
-              ghf_eb_av,        & !< average of ghf_eb
+              ghf_av,        & !< average of ghf
               lai_av,           & !< average of lai
-              qsws_eb_av,       & !< average of qsws_eb
-              qsws_liq_eb_av,   & !< average of qsws_liq_eb
-              qsws_soil_eb_av,  & !< average of qsws_soil_eb
-              qsws_veg_eb_av,   & !< average of qsws_veg_eb
+              qsws_liq_av,   & !< average of qsws_liq
+              qsws_soil_av,  & !< average of qsws_soil
+              qsws_veg_av,   & !< average of qsws_veg
               r_a_av,           & !< average of r_a
-              r_s_av,           & !< average of r_s
-              shf_eb_av           !< average of shf_eb
-
-
-!
-!-- Predefined Land surface classes (veg_type)
-    CHARACTER(26), DIMENSION(0:20), PARAMETER :: veg_type_name = (/ &
-                                   'user defined              ',    & ! 0 
-                                   'crops, mixed farming      ',    & !  1
-                                   'short grass               ',    & !  2
-                                   'evergreen needleleaf trees',    & !  3
-                                   'deciduous needleleaf trees',    & !  4
-                                   'evergreen broadleaf trees ',    & !  5
-                                   'deciduous broadleaf trees ',    & !  6
-                                   'tall grass                ',    & !  7
-                                   'desert                    ',    & !  8
-                                   'tundra                    ',    & !  9
-                                   'irrigated crops           ',    & ! 10
-                                   'semidesert                ',    & ! 11
-                                   'ice caps and glaciers     ',    & ! 12
-                                   'bogs and marshes          ',    & ! 13
-                                   'inland water              ',    & ! 14
-                                   'ocean                     ',    & ! 15
-                                   'evergreen shrubs          ',    & ! 16
-                                   'deciduous shrubs          ',    & ! 17
-                                   'mixed forest/woodland     ',    & ! 18
-                                   'interrupted forest        ',    & ! 19
-                                   'pavements/roads           '     & ! 20
+              r_s_av              !< average of r_s
+                   
+
+!
+!-- Predefined Land surface classes (vegetation_type)
+    CHARACTER(26), DIMENSION(0:18), PARAMETER :: vegetation_type_name = (/ &
+                                   'user defined              ',           & !  0 
+                                   'bare soil                 ',           & !  1                           
+                                   'crops, mixed farming      ',           & !  2
+                                   'short grass               ',           & !  3
+                                   'evergreen needleleaf trees',           & !  4
+                                   'deciduous needleleaf trees',           & !  5
+                                   'evergreen broadleaf trees ',           & !  6
+                                   'deciduous broadleaf trees ',           & !  7
+                                   'tall grass                ',           & !  8
+                                   'desert                    ',           & !  9
+                                   'tundra                    ',           & ! 10
+                                   'irrigated crops           ',           & ! 11
+                                   'semidesert                ',           & ! 12
+                                   'ice caps and glaciers     ',           & ! 13
+                                   'bogs and marshes          ',           & ! 14
+                                   'evergreen shrubs          ',           & ! 15
+                                   'deciduous shrubs          ',           & ! 16
+                                   'mixed forest/woodland     ',           & ! 17
+                                   'interrupted forest        '            & ! 18
                                                                  /)
 
 !
 !-- Soil model classes (soil_type)
-    CHARACTER(12), DIMENSION(0:7), PARAMETER :: soil_type_name = (/ &
+    CHARACTER(12), DIMENSION(0:6), PARAMETER :: soil_type_name = (/ &
                                    'user defined',                  & ! 0 
                                    'coarse      ',                  & ! 1
